/*
* Copyright (C) 2004 Ladislav Vitasek
* info@wordrider.net
* http://www.wordrider.net
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
package net.wordrider.area.actions;

import net.wordrider.area.RiderArea;
import net.wordrider.area.RiderStyles;

import javax.swing.*;
import javax.swing.text.MutableAttributeSet;
import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

/**
 * @author Vity
 */
public final class ChangeSubscriptStyleAction extends StyledAreaAction {
    private static final ChangeSubscriptStyleAction INSTANCE = new ChangeSubscriptStyleAction();
    private static final String CODE = "ChangeSubscriptStyleAction";

    public static ChangeSubscriptStyleAction getInstance() {
        return INSTANCE;
    }

    private ChangeSubscriptStyleAction() {
        super(CODE, KeyStroke.getKeyStroke(KeyEvent.VK_9, InputEvent.CTRL_MASK), "subscr.gif");
    }

    public final void actionPerformed(final ActionEvent e) {
        super.actionPerformed(e);
        final RiderArea area = getRiderArea(e);
        if (area != null) {
            final MutableAttributeSet inputAttributes = area.getInputAttributes();
            if (RiderStyles.isSubscript(inputAttributes)) {
                if (RiderStyles.isSize(inputAttributes, RiderStyles.SIZE_MINI))
                    setCharacterAttributes(area, RiderStyles.normalStyle, false);
                else {
                    setCharacterAttributes(area, RiderStyles.maxiStyle, false);
                }
            } else
                setCharacterAttributes(area, RiderStyles.miniStyle, false);
            setCharacterAttributes(area, RiderStyles.updateSubscriptAttributes(inputAttributes), false);
        }
    }


}
