/*
* Copyright (C) 2004 Ladislav Vitasek
* info@wordrider.net
* http://www.wordrider.net
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
package net.wordrider.core.actions;

import net.wordrider.core.managers.AreaManager;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

/**
 * @author Vity
 */
public final class CreateNewFileAction extends CoreAction {
    private static final CreateNewFileAction instance = new CreateNewFileAction();

    private CreateNewFileAction() {
        super("CreateNewFileAction", KeyStroke.getKeyStroke(KeyEvent.VK_N, InputEvent.CTRL_MASK), "new.gif");
    }

    public static CreateNewFileAction getInstance() {
        return instance;
    }

    public final void actionPerformed(final ActionEvent e) {
        final AreaManager areaManager = AreaManager.getInstance();
        areaManager.openFileInstance();
        areaManager.grabActiveFocus();
    }
}
