/*
* Copyright (C) 2004 Ladislav Vitasek
* info@wordrider.net
* http://www.wordrider.net
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
package net.wordrider.dialogs.pictures.filters;

/**
 * @author Vity
 */
public class Shiau1ErrorDiffusion extends DitherRaster {
    protected void performEffect() {
        for (int y = 0; y < height; y++) {
            for (int x = 0; x < width; x++) {
                final int actualIndex = y * width + x;
                final int pixel = pixels[actualIndex];
                pixels[actualIndex] = pixels[actualIndex] <= threshold ? 0 : 255;
                int k1 = pixel - pixels[actualIndex];
                if (x < width - 1)
                    pixels[actualIndex + 1] += k1 >> 1;
                if (y < height - 1) {
                    int l1 = k1 >> 4;
                    int i2 = (y + 1) * width + x;
                    if (x > 0)
                        pixels[i2 - 1] += k1 >> 3;
                    if (x - 1 > 0)
                        pixels[i2 - 2] += l1;
                    if (x - 2 > 0)
                        pixels[i2 - 3] += l1;
                    pixels[i2] += k1 >> 2;
                }
            }
        }
        quantize();
    }
}
